#include "main.h"
#include "temp_eigen.h"
#include "lcd-routines.h"
 
 
char array[4];
volatile uint8_t tick;

uint8_t scratchpad[2];
uint8_t error;
uint8_t light;
uint8_t flash;

ISR(TIMER1_COMPA_vect)					//aller 10msek.
{
  tick++;
}

int main(void)
{

//Timer1 aller 10ms bei 1MHz Taktfrequenz
TCCR1B |= ((1<<WGM12) | (1<<CS11));    // Modus 4 CTC, Prescaler 8
TIMSK |= (1<<OCIE1A);
OCR1A = 1250;     
       


//Sleep_Mode Init
set_sleep_mode(SLEEP_MODE_IDLE);				//Init Sleep-Modus auf IDLE

//Anzeige init
lcd_init();

//4x Minus-Zeichen am Anfang
array[0] = '-';		
array[1] = '-';
array[2] = '-';
array[3] = '-';		
array[4] = '-';

sei();

  for(;;)
  {
    uint8_t digit;
	cli();

	switch (tick)
	{
		case 1:
		{
			if(therm_reset())
				error = 1;
			else
				error = 0;
			if (!(error))
			{
				therm_write_byte(THERM_CMD_SKIPROM);
				therm_write_byte(THERM_CMD_CONVERTTEMP);
			}
		break;
		}


		case 81:				//nach 800msek.
		{
			if (!(error))
			{
				therm_reset();
				therm_write_byte(THERM_CMD_SKIPROM);
				therm_write_byte(THERM_CMD_RSCRATCHPAD);
				scratchpad[0]=therm_read_byte();
				scratchpad[1]=therm_read_byte();
			}

		break;
		}


		case 82:
		{
			if (!(error))
			{
				if (scratchpad[1] != 0)		//negative Temperatur
				{
					digit = ((0xff-scratchpad[0]) +1)>>1;
					if (digit < 10)
					{
						array[0] = ' ';
						array[1] = '-';							//Minus-Zeichen setzen
						array[2] = (digit%10) + '0';
						array[3] = 0xDF;
						array[4] = 'C';
					}
					else
					{
						array[0] = '-';							//Minus-Zeichen setzen
						array[1] = ((digit/10)% 10)+ '0';		//zehner Stelle
						array[2] = (digit%10) + '0';			//einer stelle
						array[3] = 0xDF;
						array[4] = 'C';
					}
					
				}
				else
				{
					digit=scratchpad[0]>>1;
					if (digit < 10)
					{
						array[0] = ' ';			    
						array[1] = ' ';						//vorstellen-Null ausblenden
						array[2] = (digit%10) + '0';
						array[3] = 0xDF;
						array[4] = 'C';
					}
					else
					{
						array[0] = ' ';	
						array[1] = ((digit/10)% 10)+ '0';		//zehner Stelle
						array[2] = (digit%10) + '0';			//einer stelle
						array[3] = 0xDF;
						array[4] = 'C';
					}
				}
			}
			else
			{
				if (!(flash))
				{
					array[0] = 'E';
					array[1] = 'r';
					array[2] = 'r';
					array[3] = ' ';
					flash = 1;
				}
				else
				{
					array[0] = 'S';
					array[1] = 'e';
					array[2] = 'n';
					array[3] = 's';
					flash = 0;
				}
			}
		break;
		}
		case 83:
		{
			lcd_setcursor( 0, 2 );
			lcd_string("Temperatur:");
			lcd_setcursor( 11, 2 );
			lcd_string(array);
			lcd_setcursor( 0, 1 );
			lcd_string("-Happy Birthday-");
			tick = 0;
		break;
		}
    }

   sei();
   sleep_mode();
  }
}	
